<template>
  <ModalDefault
    width="340px"
    height="initial"
    customStyle="padding:0px;"
    btnTitle="View Details"
    ref="modal">
    <div
      class="profile_resources card">
      <div class="profile_resources-header">
        <div class="profile_resources-header-title">
          {{$t('profile.eosResources')}}
        </div>
        <div class="profile_resources-header-func">
          <v-popover
            offset="16"
            placement="left">
            <img
              class="profile-info"
              src="~/static/icons/information.png"
              alt="">
            <template slot="popover">
              {{$t('helpers.resources')}}
            </template>
          </v-popover>
        </div>
      </div>
      <div class="profile_resources-info">
        {{$t('profile.additionalTransaction')}}
      </div>
      <div class="profile_resources-inner">
        <div
          class="profile_resources-body">
          <div class="profile_resources-type">
            <div class="profile_resources-type-name profile_resources-type-ram">
              {{$t('profile.ram')}}
            </div>
            <div class="profile_resources-type-progress">
              <div class="profile_resources-type-progress-stacked">
                <span>{{ram.price}} EOS</span>
              </div>
              <ProgressBar
                :value="ram.progress+'%'"
                type="green"></ProgressBar>
              <div class="profile_resources-type-progress-bets flex flex-between">
                <div></div>
                <div>{{ram.amount}} Bytes</div>
              </div>
            </div>
          </div>
          <div class="profile_resources-type">
            <div class="profile_resources-type-name profile_resources-type-cpu">
              {{$t('profile.cpu')}}
            </div>
            <div class="profile_resources-type-progress">
              <div class="profile_resources-type-progress-stacked">
                <span>{{cpu.price}} EOS</span>
              </div>
              <ProgressBar
                :value="cpu.progress+'%'"
                type="deepOrange"></ProgressBar>
              <div class="profile_resources-type-progress-bets flex flex-between">
                <div></div>
                <div>{{cpu.amount}} ms</div>
              </div>
            </div>
          </div>
          <div class="profile_resources-type">
            <div class="profile_resources-type-name profile_resources-type-net">
              {{$t('profile.net')}}
            </div>
            <div class="profile_resources-type-progress">
              <div class="profile_resources-type-progress-stacked">
                <span>{{net.price}} EOS</span>
              </div>
              <ProgressBar
                :value="net.progress+'%'"
                type="deepBlue"></ProgressBar>
              <div class="profile_resources-type-progress-bets flex flex-between">
                <div></div>
                <div>{{net.amount}} KB</div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <template slot="footer">
      <div class="profile_resources_footer">
        <div class="text-center text-huge color-white"><span class="text-bold">{{totalPrice}}</span>
          <span class="text-light">EOS</span></div>
        <div class="flex profile_resources_footer-btn">
          <Btn
            transparent
            @click="cancel"><span class="color-white">{{$t('common.cancel')}}</span></Btn>
          <Btn
            :loading="loading"
            @click="buy">{{$t('common.accept')}}
          </Btn>
        </div>
      </div>
    </template>
  </ModalDefault>
</template>

<script>
  import ModalDefault from '~/components/UI/Modal/Default';
  import ProgressBar from '~/components/UI/Progress';
  import {mapState} from 'vuex';
  import Btn from '~/components/UI/BtnSign_plain';
  import notification
    from '~/components/UI/Notification/main.js';
  import {flooring} from "../../utils";
  import resourceManager from '~/services/resourceManager';

  const findCpuAmount = (string) => {
    return string.match(/\(\S* \D*\)/gim) ? string.match(/\(\S* \D*\)/gim)[0].replace(/[\(\)]/gi, '') : 0;
  };

  const findRamAmount = (string) => {
    return string.match(/needs \d*/gi) ? string.match(/needs \d*/gi)[0].replace(/[needs,\s]/gi, '') : 0;
  };

  const findNetAmount = (string) => {
    return string.match(/too high: \d*/gi) ? string.match(/too high: \d*/gi)[0].replace(/[too high:\s]/gi, '') : 0;
  };

  const pause = (ms) => new Promise(resolve => setTimeout(_ => {
    resolve();
  }, ms));

  export default {
    name: "TheAdditionalResourcesModal",
    data() {
      return {
        ram: {
          amount: 500,
          price: 0,
          multiplier: 1,
          progress: 0
        },
        cpu: {
          amount: 3,
          price: 0,
          multiplier: 1000,
          frac: 0,
          progress: 0
        },
        net: {
          amount: 10,
          price: 0,
          multiplier: 1024,
          frac: 0,
          progress: 0
        },
        totalPrice: 0,
        rexInfo: {},
        loading: false
      }
    },
    components: {
      ModalDefault,
      ProgressBar,
      Btn
    },
    computed: {
      ...mapState({
        resources: state => state.wallet.calculatedResources,
        ramPrice: state => state.wallet.price.ram
      })
    },
    methods: {
      show(errorString = '') {
        if (errorString.search('billed CPU time') > -1) {
          const numberChunk = findCpuAmount(errorString);
          this.cpu.amount = parseInt(numberChunk) / 1000;
          this.$refs['modal'].show();
          this.calculatePrices();
          return false;
        } else if (errorString.search('has insufficient ram') > -1) {
          const numberChunk = findRamAmount(errorString);
          this.ram.amount = parseInt(numberChunk);
          this.$refs['modal'].show();
          this.calculatePrices();
          return false;
        } else if (errorString.search('net usage') > -1) {
          const numberChunk = findNetAmount(errorString);
          this.net.amount = parseInt(numberChunk) * 2;
          this.$refs['modal'].show();
          this.calculatePrices();
          return false;
        } else {
          return errorString;
        }
      },
      async buy() {
        this.loading = true;
        const [err, res] = await this.$store.dispatch('user/stackAndPowerup', {
          ram: this.ram.amount,
          cpu_frac: this.cpu.frac,
          net_frac: this.net.frac,
          max_payment: this.totalPrice - this.ram.price
        });
        if (err) {
          this.loading = false;
          this.show(err.message);
          notification.error({
            message: err.message,
          });
        } else {
          await pause(5000);
          this.$emit('submit', this.totalPrice);
        }
      },
      cancel() {
        this.$refs['modal'].show(false);
      },
      calculatePrices() {
        const rentedRam = parseInt(this.ramPrice * this.ram.amount * this.ram.multiplier * 10000) / 10000;
        this.ram.price = Math.round(rentedRam * 10000) / 10000;
        const cpuInfo = resourceManager.calcCpu(this.cpu.amount * this.cpu.multiplier);
        const netInfo = resourceManager.calcNet(this.net.amount * this.net.multiplier);
        let max_payment = cpuInfo.price;
        this.cpu.frac = cpuInfo.frac;
        this.net.frac = netInfo.frac;
        max_payment = Math.max(max_payment, netInfo.price) * 1.5;
        this.cpu.price = cpuInfo.price;
        this.net.price = netInfo.price;
        this.totalPrice = flooring(this.ram.price + max_payment);
        this.ram.progress = flooring(this.ram.price / this.totalPrice * 100);
        this.cpu.progress = flooring(this.cpu.price / this.totalPrice * 100);
        this.net.progress = flooring(this.net.price / this.totalPrice * 100);
      }
    },
    mounted() {
      this.$store.dispatch('wallet/getRexInfo').then(res => {
        this.rexInfo = res;
        this.$store.dispatch('wallet/checkRamPrice');
      }).catch(e => {
        console.log('get rex info error - ', e);
      })
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .profile {
    &_resources {
      margin: 0px;
      border: 0px;
      box-shadow: none;
      border-bottom-left-radius: 0px;
      border-bottom-right-radius: 0px;
      &-info {
        background-color: #313c4e;
        color: #a5b5d1;
        padding: 15px;
        font-size: .725rem;
        text-transform: initial;
        line-height: 1.4;
      }
      &-type {
        &-progress {
          &-stacked {
            font-weight: normal;
            color: inherit;
          }
        }
        &-name {
          font-size: .775rem;
          min-width: 50px;
          border-width: 1px;
        }
      }
      &_footer {
        background-color: #1e293f;
        padding: 15px 0px;
        &-btn {
          padding: 15px 5px 0px 5px;
        }
      }
    }
  }
</style>
